#include "generator.h"

Generator::Generator(QObject *parent)
    : QObject(parent)
{
}

Generator::~Generator()
{
}

void Generator::generate()
{
    QElapsedTimer timer;
    timer.start();

    m_points.clear();
    emit pointsChanged(m_points);

    m_vector.clear();
    m_vector.reserve(m_count);
    for (quint64 i(0); i < m_count; i++) {
        m_vector.append(QPointF(M_PI * 10 / m_count * i, qSin(M_PI * 10 / m_count * i) + QRandomGenerator::global()->generateDouble() * 0.1 - 0.05));
    }

    m_points.setValue(&m_vector);
    m_genrationTime = timer.elapsed();

    emit genrationTimeChanged(m_genrationTime);
    emit pointsChanged(m_points);
}
