#pragma once

#include <QtCore>
#include <QElapsedTimer>

Q_DECLARE_METATYPE(QVector<QPointF>*)

class Generator : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(Generator)
    Q_PROPERTY(quint64 count MEMBER m_count NOTIFY countChanged)
    Q_PROPERTY(qint64 genrationTime MEMBER m_genrationTime NOTIFY genrationTimeChanged)
    Q_PROPERTY(QVariant points MEMBER m_points NOTIFY pointsChanged)

public:
    explicit Generator(QObject *parent = nullptr);
    ~Generator() override;

    Q_INVOKABLE void generate();

signals:
    void countChanged(quint64 arg);
    void genrationTimeChanged(qint64 arg);
    void pointsChanged(QVariant arg);

private:
    quint64 m_count{};
    qint64 m_genrationTime{};
    QVariant m_points;
    QVector<QPointF> m_vector;
};
