#pragma once

#include <QtCore>
#include <QtCharts>

Q_DECLARE_METATYPE(QVector<QPointF>*)

class Plotter : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(Plotter)
    Q_PROPERTY(QVariant points MEMBER m_points NOTIFY pointsChanged)

public:
    explicit Plotter(QObject *parent = nullptr);
    ~Plotter() override;
    Q_INVOKABLE void updateSeries(QAbstractSeries *series);

signals:
    void pointsChanged(QVariant arg);

private:
    QVariant m_points;
};
